﻿namespace ProjectCleaningCar.Entities;
/// <summary>
/// Класс-сущность "Подметательно-уборочная машина"
/// </summary>
public class EntityCleaningCar : EntityTruck
{
    /// <summary>
    /// Дополнительный цвет (для опциональных элементов)
    /// </summary>
    public Color AdditionalColor { get; private set; }
    /// <summary>
    /// Признак (опция) наличия бака
    /// </summary>
    public bool Tank { get; private set; }
    /// <summary>
    /// Признак (опция) наличия щётки
    /// </summary>
    public bool SweepingBrush { get; private set; }
    /// <summary>
    /// Признак (опция) наличия проблескового маячка
    /// </summary>
    public bool Flashlight { get; private set; }
    /// <summary>
    /// Инициализация полей объекта-класса подметально-уборочной машины
    /// </summary>
    /// <param name="speed">Скорость</param>
    /// <param name="weight">Вес автомобиля</param>
    /// <param name="bodyColor">Основной цвет</param>
    /// <param name="additionalColor">Дополнительный цвет</param>
    /// <param name="tank">Признак наличия бака под воду</param>
    /// <param name="sweepingBrush">Признак наличия подметательной щётки</param>
    /// <param name="flashlight">Признак наличия проблескового маячка</param>
    public EntityCleaningCar(int speed, double weight, Color bodyColor, Color additionalColor, bool tank, bool sweepingBrush, bool flashlight) : base(speed, weight, bodyColor)
    {
        AdditionalColor = additionalColor;
        Tank = tank;
        SweepingBrush = sweepingBrush;
        Flashlight = flashlight;
    }
}
