﻿namespace ProjectCleaningCar.Entities;
/// <summary>
/// Класс-сущность "Грузовик"
/// </summary>
public class EntityTruck
{
    /// <summary>
    /// Скорость
    /// </summary>
    public int Speed { get; private set; }
    /// <summary>
    /// Вес
    /// </summary>
    public double Weight { get; private set; }
    /// <summary>
    /// Основной цвет
    /// </summary>
    public Color BodyColor { get; private set; }
    /// <summary>
    /// Шаг перемещения грузовика
    /// </summary>
    public double Step => Speed * 200 / Weight;

    /// <summary>
    /// Инициализация полей объекта-класса грузовик
    /// </summary>
    /// <param name="speed">Скорость</param>
    /// <param name="weight">Вес автомобиля</param>
    /// <param name="bodyColor">Основной цвет</param>
    public EntityTruck(int speed, double weight, Color bodyColor)
    {
        Speed = speed;
        Weight = weight;
        BodyColor = bodyColor;
    }
}
